#include "paraclass.h"
#include <stdio.h>
#define INPORTB 'in8'
#define OUTPORTB 'ou8'
#define INPORTW 'in16'
#define OUTPORTW 'ou16'

typedef struct IO_Tuple
{
	unsigned long Port;
	unsigned char  Data;
	unsigned short Data16;
} IO_Tuple;



unsigned char ParPort::In(unsigned short port)
{
	IO_Tuple temp;
	
	temp.Port = port;

	//ioctl(fd, DRV_READ_IO_8, &temp, 0);
	ioctl(fd, INPORTB, &temp, 0);
	
	return (temp.Data);
}

unsigned short ParPort::In16(unsigned short port)
{
	IO_Tuple temp;
	
	temp.Port = port;
	
	//ioctl(fd, DRV_READ_IO_16, &temp, 0);
	ioctl(fd, INPORTW, &temp, 0);
	
	return (temp.Data16);
}



void ParPort::Out(unsigned short port, unsigned char byte)
{
	IO_Tuple temp;
	
	temp.Port = port;
    temp.Data = byte;

	//ioctl(fd, DRV_WRITE_IO_8, &temp, 0);
	ioctl(fd, OUTPORTB, &temp, 0);
	
	return;
}

void ParPort::Out16(unsigned short port, unsigned short word)
{
	IO_Tuple temp;
	
	temp.Port = port;
	temp.Data16 = word;
	
	//ioctl(fd, DRV_WRITE_IO_16, &temp, 0);
	ioctl(fd, OUTPORTW, &temp, 0);
	return;
}

void ParPort::Open()
{
	fd = open("/dev/misc/alienparallel", O_RDWR | O_NONBLOCK);
}

void ParPort::Close()
{
	close(fd);
}
